/**
 * App component script
 */
import { Component, ViewChild, AfterViewInit, ViewEncapsulation } from '@angular/core';
import { BryntumTaskBoardComponent, BryntumProjectModelComponent } from '@bryntum/taskboard-angular';
import { TaskBoard } from '@bryntum/taskboard';

import { taskBoardConfig } from './app.config';
import { projectData } from './app.data';

@Component({
    selector      : 'app-root',
    templateUrl   : './app.component.html',
    styleUrls     : ['./app.component.scss'],
    encapsulation : ViewEncapsulation.None
})

export class AppComponent implements AfterViewInit {

    taskBoardConfig = taskBoardConfig;
    projectData = projectData;

    // Bryntum TaskBoard Angular wrapper reference
    @ViewChild(BryntumTaskBoardComponent, { static : false }) taskboardComponent: BryntumTaskBoardComponent;
    @ViewChild(BryntumProjectModelComponent, { static : true }) project: BryntumProjectModelComponent;

    private taskboard : TaskBoard;

    ngAfterViewInit(): void {
        this.taskboard = this.taskboardComponent.instance;
        this.taskboard.swimlanes.on('change',  this.swimlaneChange.bind(this));
    }

    swimlaneChange(e : any) : void {
        if (e.action === 'move') {
            console.log(e)
        }
    }
}
